## leatherman 1.4.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2.2)
project(leatherman VERSION 1.4.0)

if (WIN32)
    link_libraries("-Wl,--nxcompat -Wl,--dynamicbase")
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" "${PROJECT_BINARY_DIR}/cmake")
# Populate locale install location
configure_file(cmake/leatherman.cmake.in "${PROJECT_BINARY_DIR}/cmake/leatherman.cmake" @ONLY)
include(internal)

# If we're the top-level project, we want to ensure the build type is
# sane, and flag ourselves as such for later checks
if ("${CMAKE_PROJECT_NAME}" STREQUAL "${PROJECT_NAME}")
    if (NOT CMAKE_BUILD_TYPE)
        message(STATUS "Defaulting to a release build.")
        set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
    endif()

    set(LEATHERMAN_TOPLEVEL TRUE)
else()
    set(LEATHERMAN_TOPLEVEL FALSE)
endif()

# If we're the top-level project enable everything by default
defoption(LEATHERMAN_DEFAULT_ENABLE "Should Leatherman libraries all be built by default" ${LEATHERMAN_TOPLEVEL})
defoption(LEATHERMAN_DEBUG "Enable verbose logging messages from leatherman macros" FALSE)
defoption(LEATHERMAN_ENABLE_TESTING "Build the leatherman test binary" ${LEATHERMAN_DEFAULT_ENABLE})
defoption(LEATHERMAN_INSTALL "Install the leatherman libraries and headers" ${LEATHERMAN_DEFAULT_ENABLE})
defoption(LEATHERMAN_SHARED "Create shared libraries instead of static" FALSE)

set(BUILDING_LEATHERMAN TRUE)

#As with most things, we rely on the containing project to set up the
#common flags
if (LEATHERMAN_TOPLEVEL)
    include(options)
    include(cflags)
endif()

if (${LEATHERMAN_SHARED} AND (WIN32 OR ${CURL_STATIC}))
    set(MOCK_CURL FALSE)
else()
    set(MOCK_CURL TRUE)
endif()
defoption(LEATHERMAN_MOCK_CURL "Use mock curl library for testing Leatherman.curl" ${MOCK_CURL})

add_definitions(${LEATHERMAN_DEFINITIONS})
if (LEATHERMAN_LOCALE_VAR AND LEATHERMAN_LOCALE_INSTALL)
    # Add an environment variable to look up install prefix at runtime.
    add_definitions(-DLEATHERMAN_LOCALE_VAR="${LEATHERMAN_LOCALE_VAR}"
                    -DLEATHERMAN_LOCALE_INSTALL="${LEATHERMAN_LOCALE_INSTALL}")
else()
    # Add install location instead.
    add_definitions(-DLEATHERMAN_LOCALE_INSTALL="${CMAKE_INSTALL_PREFIX}/share/locale")
endif()

file(GLOB_RECURSE ALL_LEATHERMAN_SOURCES */src/*.cc */inc/*.hpp)
add_subdirectory(locales)

add_leatherman_dir(nowide)
add_leatherman_dir(util)
add_leatherman_dir(locale)
add_leatherman_dir(logging)
add_leatherman_dir(json_container)
add_leatherman_dir(file_util)
add_leatherman_dir(curl)
if (WIN32)
  add_leatherman_dir(windows)
endif()
add_leatherman_dir(dynamic_library)
add_leatherman_dir(execution)
add_leatherman_dir(ruby)

# Ensure no LEATHERMAN_LIBS are in LEATHERMAN_DEPS, LEATHERMAN_LIBS should be declared in dependency
# order above, and we don't want them to come after other dependencies.
if (LEATHERMAN_LIBS)
    list(REMOVE_ITEM LEATHERMAN_DEPS ${LEATHERMAN_LIBS})
endif()
if (LEATHERMAN_LIBS OR LEATHERRMAN_DEPS)
    if (LEATHERMAN_SHARED)
        # When using shared libraries, leave out dependencies as they're already handled in the shared libs.
        # Including deps after the shared libraries can lead to "multiple definition" errors.
        list(APPEND LEATHERMAN_LIBRARIES ${LEATHERMAN_LIBS})
    else()
        list(APPEND LEATHERMAN_LIBRARIES ${LEATHERMAN_LIBS} ${LEATHERMAN_DEPS})
    endif()
endif()
if (LEATHERMAN_INCLUDE_DIRS)
    list(REMOVE_DUPLICATES LEATHERMAN_INCLUDE_DIRS)
endif()

export_var(LEATHERMAN_INCLUDE_DIRS)
export_var(LEATHERMAN_LIBRARIES)

if(LEATHERMAN_ENABLE_TESTING)
    enable_testing()
    add_subdirectory(tests)

    add_cppcheck_dirs(${LEATHERMAN_CPPCHECK_DIRS})

    add_cpplint_files(${ALL_LEATHERMAN_SOURCES})

    # If we're toplevel we want to own these targets. If not we assume
    # that containing project will set them up for us.
    if (LEATHERMAN_TOPLEVEL)
        enable_cppcheck()
        enable_cpplint()
    endif()
endif()

# Install the cmake files we need for consumers
if (LEATHERMAN_INSTALL)
    set(CMAKE_FILES
        cmake/cflags.cmake
        cmake/GetGitRevisionDescription.cmake
        cmake/GetGitRevisionDescription.cmake.in
        cmake/pod2man.cmake
        cmake/options.cmake
        cmake/leatherman_config.cmake
        cmake/normalize_pot.cmake
        cmake/generate_translations.cmake
    )
    set(INSTALL_LOC "lib${LIB_SUFFIX}/cmake/leatherman")
    install(FILES
        ${CMAKE_FILES}
        "${PROJECT_BINARY_DIR}/cmake/leatherman.cmake"
        DESTINATION "${INSTALL_LOC}/cmake/")

    configure_file(LeathermanConfig.cmake.in "${PROJECT_BINARY_DIR}/LeathermanConfig.cmake" @ONLY)
    configure_file(LeathermanConfigVersion.cmake.in "${PROJECT_BINARY_DIR}/LeathermanConfigVersion.cmake" @ONLY)
    install(FILES
        "${PROJECT_BINARY_DIR}/LeathermanConfig.cmake"
        "${PROJECT_BINARY_DIR}/LeathermanConfigVersion.cmake"
        DESTINATION ${INSTALL_LOC})
    install(EXPORT LeathermanLibraries DESTINATION ${INSTALL_LOC})

    install(FILES "scripts/cpplint.py" DESTINATION "${INSTALL_LOC}/scripts/")
endif()

=== catch/CMakeLists.txt ===
add_leatherman_vendored("Catch-1.10.0.zip" "Catch-1.10.0" "single_include")

=== json_container/CMakeLists.txt ===
find_package(Boost 1.54 REQUIRED COMPONENTS regex)

add_leatherman_deps("${Boost_LIBRARIES}")
add_leatherman_includes("${Boost_INCLUDE_DIRS}")

leatherman_dependency(locale)

add_leatherman_library("src/json_container.cc")
add_leatherman_headers("inc/leatherman")
add_leatherman_test("tests/json_container_test.cc")

=== locale/CMakeLists.txt ===
if (LEATHERMAN_USE_LOCALES)
    find_package(Boost 1.54 REQUIRED COMPONENTS locale system)
else()
    find_package(Boost 1.54 REQUIRED regex)
endif()

add_leatherman_includes(${Boost_INCLUDE_DIRS})
add_leatherman_deps(${Boost_LIBRARIES})

if (LEATHERMAN_USE_LOCALES AND BOOST_STATIC AND APPLE)
    # Boost.Locale relies on libiconv; if not using shared boost libraries
    # we need to include the dependency ourselves. So far this is only a
    # problem on Mac OS X.
    add_leatherman_deps(iconv)
endif()

leatherman_dependency(util)

add_leatherman_headers(inc/leatherman)

if (LEATHERMAN_USE_LOCALES)
    add_leatherman_library(src/locale.cc)
    if (GETTEXT_ENABLED)
        # This test relies on translation .mo files being generated.
        # Projects that don't support localization yet still need
        # tests to pass, so only enable these tests if gettext is
        # available.
        add_leatherman_test(tests/locale.cc)
    endif()
else()
    add_leatherman_library(disabled/locale.cc)
endif()

add_leatherman_test(tests/format.cc)

if (LEATHERMAN_USE_LOCALES AND BUILDING_LEATHERMAN)
    project(leatherman_locale)
    add_subdirectory(locales)
endif()

=== locales/CMakeLists.txt ===
if (LEATHERMAN_TOPLEVEL)
    gettext_templates(${CMAKE_CURRENT_SOURCE_DIR} ${ALL_LEATHERMAN_SOURCES})
endif()
gettext_compile(${CMAKE_CURRENT_SOURCE_DIR} share/locale)
SET_DIRECTORY_PROPERTIES(PROPERTIES CLEAN_NO_CUSTOM TRUE)
export_var(GETTEXT_ENABLED)

=== nowide/CMakeLists.txt ===
find_package(Boost 1.54 REQUIRED)

add_leatherman_includes(${Boost_INCLUDE_DIRS} "${CMAKE_CURRENT_SOURCE_DIR}/../vendor/nowide/include")
add_leatherman_headers(../vendor/nowide/include/boost)
if(WIN32)
    add_leatherman_library(../vendor/nowide/src/iostream.cpp)
endif()

=== ruby/CMakeLists.txt ===
find_package(Boost 1.54 REQUIRED COMPONENTS regex filesystem system)

add_leatherman_deps("${Boost_LIBRARIES}")
add_leatherman_includes("${Boost_INCLUDE_DIRS}")

leatherman_dependency(dynamic_library)
leatherman_dependency(util)
leatherman_dependency(execution)

leatherman_dependency(locale)
leatherman_dependency(logging)
if (BUILDING_LEATHERMAN)
    leatherman_logging_namespace("leatherman.ruby")
    leatherman_logging_line_numbers()
endif()

add_leatherman_headers(inc/leatherman)

if(WIN32)
    set(PLATFORM_SRCS src/windows/api.cc)
else()
    set(PLATFORM_SRCS src/posix/api.cc)
endif()

add_leatherman_library(src/api.cc ${PLATFORM_SRCS})
add_leatherman_test(tests/api-test.cc)

=== windows/CMakeLists.txt ===
find_package(Boost 1.54 REQUIRED COMPONENTS filesystem)

add_leatherman_deps(Wbemuuid.lib userenv.lib "${Boost_LIBRARIES}")
add_leatherman_includes("${Boost_INCLUDE_DIRS}")

leatherman_dependency(nowide)
leatherman_dependency(locale)
leatherman_dependency(logging)
leatherman_dependency(util)

if (BUILDING_LEATHERMAN)
    leatherman_logging_namespace("leatherman.windows")
    leatherman_logging_line_numbers()
endif()

set(WINDOWS_UTIL_SOURCES
  "src/file_util.cc"
  "src/registry.cc"
  "src/process.cc"
  "src/user.cc"
  "src/wmi.cc"
  "src/system_error.cc"
)

add_leatherman_library(${WINDOWS_UTIL_SOURCES})
add_leatherman_headers(inc/leatherman)
add_leatherman_test(tests/file_utils_test.cc)

=== vendor/nowide/standalone/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

include_directories(.)
enable_testing()

option(RUN_WITH_WINE		"Use wine to run tests" OFF)


if(NOT LIBDIR)
	set(LIBDIR lib CACHE STRING "Library installation directory" FORCE)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
	set(CXX_FLAGS "-Wall -Wextra")
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
	set(CXX_FLAGS "-Wall -Wextra")
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
	set(CXX_FLAGS "-Wall")
elseif(MSVC)
	set(CXX_FLAGS "/EHsc /W3")
endif()

if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
	if(MSVC)
		set(NOWIDE_SUFFIX "-d")
	endif()
endif()



set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX_FLAGS}")

set(NOWIDE_TESTS
    test_convert
    test_stdio
    test_fstream
    )

foreach(TEST ${NOWIDE_TESTS})
    add_executable(${TEST} test/${TEST}.cpp)
    if(RUN_WITH_WINE)
       add_test(NAME ${TEST} WORKING_DIRECTORY ${CMAKE_BUILD_DIR} COMMAND wine ./${TEST}.exe)
    else()
       add_test(${TEST} ${TEST})
    endif()
endforeach()

add_library(nowide SHARED src/iostream.cpp)
set_target_properties(nowide	PROPERTIES VERSION 0.0.0 SOVERSION 0)
set_target_properties(nowide 	PROPERTIES
				CLEAN_DIRECT_OUTPUT 1
				OUTPUT_NAME "nowide${NOWIDE_SUFFIX}"
			)

add_library(nowide-static STATIC src/iostream.cpp)
set_target_properties(nowide-static PROPERTIES
				CLEAN_DIRECT_OUTPUT 1
				OUTPUT_NAME "nowide${NOWIDE_SUFFIX}"
			)

if(MSVC)
	set_target_properties(nowide-static PROPERTIES PREFIX "lib")
endif()

add_executable(test_iostream_shared test/test_iostream.cpp)
set_target_properties(nowide PROPERTIES COMPILE_DEFINITIONS DLL_EXPORT)
set_target_properties(test_iostream_shared PROPERTIES COMPILE_DEFINITIONS DLL_EXPORT)
target_link_libraries(test_iostream_shared nowide)

add_executable(test_iostream_static test/test_iostream.cpp)
target_link_libraries(test_iostream_static nowide-static)

add_executable(test_system test/test_system.cpp)


add_executable(test_env_proto test/test_env.cpp)
add_executable(test_env_win test/test_env.cpp)
set_target_properties(test_env_win PROPERTIES COMPILE_DEFINITIONS NOWIDE_TEST_INCLUDE_WINDOWS)

set(OTHER_TESTS test_iostream_shared test_iostream_static test_env_win test_env_proto)

if(RUN_WITH_WINE)
	foreach(T ${OTHER_TESTS})
		add_test(NAME ${T} WORKING_DIRECTORY ${CMAKE_BUILD_DIR} COMMAND wine ./${T}.exe)
	endforeach()

	add_test(NAME test_system_n WORKING_DIRECTORY ${CMAKE_BUILD_DIR} COMMAND wine ./test_system.exe "-n")
	add_test(NAME test_system_w WORKING_DIRECTORY ${CMAKE_BUILD_DIR} COMMAND wine ./test_system.exe "-w")
else()
	foreach(T ${OTHER_TESTS})
		add_test(${T} ${T})
	endforeach()

	add_test(test_system_n test_system "-n")
	add_test(test_system_w test_system "-w")
endif()

install(TARGETS nowide nowide-static
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION ${LIBDIR}
	ARCHIVE DESTINATION ${LIBDIR})

install(DIRECTORY nowide DESTINATION include)

=== debian/changelog ===
leatherman (1.4.0+dfsg-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
    - Loosen Build-Dependency on debhelper
    - Tighten Build-Dependency on catch
    - Adjust gbp configuration

 -- Nicolas Dandrimont <olasd@debian.org>  Thu, 22 Mar 2018 15:17:58 +0100

leatherman (1.4.0+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #891226)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Fri, 23 Feb 2018 15:01:44 +0200

=== debian/control ===
Source: leatherman
Priority: optional
Maintainer: Puppet Package Maintainers <pkg-puppet-devel@lists.alioth.debian.org>
Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 11~),
 libboost-dev,
 libboost-log-dev,
 libboost-locale-dev,
 libboost-thread-dev,
 libboost-date-time-dev,
 libboost-filesystem-dev,
 libboost-system-dev,
 libboost-chrono-dev,
 libboost-regex-dev,
 libcurl4-openssl-dev,
 libruby,
 rapidjson-dev,
 catch (>= 1.10~),
Standards-Version: 4.1.3
Section: libs
Homepage: https://github.com/puppetlabs/leatherman
Vcs-Git: https://salsa.debian.org/puppet-team/leatherman.git
Vcs-Browser: https://salsa.debian.org/puppet-team/leatherman

Package: libleatherman-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libleatherman1.4.0 (= ${binary:Version}),
 libboost-dev,
 libboost-log-dev,
 libboost-locale-dev,
 libboost-thread-dev,
 libboost-date-time-dev,
 libboost-filesystem-dev,
 libboost-system-dev,
 libboost-chrono-dev,
 libboost-regex-dev,
 libcurl4-openssl-dev,
 ${misc:Depends},
Description: collection of C++ and CMake utility libraries - development files
 Leatherman is a collection of C++ and CMake utility libraries, primarily used
 in the Puppet ecosystem.
 .
 This package contains the C++ headers and the CMake utility libraries.

Package: libleatherman-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: collection of C++ and CMake utility libraries - support data
 Leatherman is a collection of C++ and CMake utility libraries, primarily used
 in the Puppet ecosystem.
 .
 This package contains support data for leatherman.

Package: libleatherman1.4.0
Architecture: any
Multi-Arch: same
Depends: libleatherman-data (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: collection of C++ and CMake utility libraries - shared libraries
 Leatherman is a collection of C++ and CMake utility libraries, primarily used
 in the Puppet ecosystem.
 .
 This package contains the actual shared libraries.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DLEATHERMAN_SHARED=ON

override_dh_auto_test:
	# Tests are locale-dependent
	LC_ALL=C LC_CTYPE=C dh_auto_test

override_dh_missing:
	dh_missing --fail-missing

## leatherman 1.4.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.2.2)
-project(leatherman VERSION 1.4.0)
+project(leatherman VERSION 1.4.2)
 
 if (WIN32)
     link_libraries("-Wl,--nxcompat -Wl,--dynamicbase")
@@ -29,6 +29,7 @@
 defoption(LEATHERMAN_ENABLE_TESTING "Build the leatherman test binary" ${LEATHERMAN_DEFAULT_ENABLE})
 defoption(LEATHERMAN_INSTALL "Install the leatherman libraries and headers" ${LEATHERMAN_DEFAULT_ENABLE})
 defoption(LEATHERMAN_SHARED "Create shared libraries instead of static" FALSE)
+defoption(LEATHERMAN_USE_ICU "Set when Boost is built with ICU" FALSE)
 
 set(BUILDING_LEATHERMAN TRUE)

=== dynamic_library/CMakeLists.txt ===
find_package(Boost 1.54 REQUIRED COMPONENTS regex)

add_leatherman_deps("${Boost_LIBRARIES}")
add_leatherman_includes("${Boost_INCLUDE_DIRS}")

leatherman_dependency(locale)
leatherman_dependency(logging)
leatherman_dependency(util)
if(WIN32)
    leatherman_dependency(windows)
else()
  if(NOT CMAKE_SYSTEM_NAME MATCHES "FreeBSD|OpenBSD")
      add_leatherman_deps(dl)
  endif()
endif()

if (BUILDING_LEATHERMAN)
    leatherman_logging_namespace("leatherman.dynamic_library")
    leatherman_logging_line_numbers()
endif()

add_leatherman_headers(inc/leatherman)
if(WIN32)
    add_leatherman_library(src/windows/dynamic_library.cc src/dynamic_library.cc)
else()
    add_leatherman_library(src/posix/dynamic_library.cc src/dynamic_library.cc)
endif()

add_leatherman_test(tests/dynamic_library_tests.cc)

if (BUILDING_LEATHERMAN)

    #Build dummy dynamic libraries for use in testing
    add_library(libtest SHARED tests/test-lib/hello.cc)
    set_target_properties(libtest PROPERTIES PREFIX "" SUFFIX ".so")
    add_library(libtest1 SHARED tests/test-lib/hello.cc tests/test-lib/goodbye.cc)
    set_target_properties(libtest1 PROPERTIES PREFIX "" SUFFIX ".so")

    configure_file (
        "${CMAKE_CURRENT_LIST_DIR}/tests/fixtures.hpp.in"
        "${CMAKE_CURRENT_LIST_DIR}/tests/fixtures.hpp"
    )
endif()

=== execution/CMakeLists.txt ===
find_package(Boost 1.54 REQUIRED COMPONENTS regex filesystem system)

add_leatherman_deps("${Boost_LIBRARIES}")
if ("${CMAKE_SYSTEM_NAME}" MATCHES "SunOS")
    # We use functions provided by this library in the implementation
    # of the create_detached_process execution option on Solaris to
    # execute the child processes in their own contracts
    add_leatherman_deps(contract)
endif()
add_leatherman_includes("${Boost_INCLUDE_DIRS}")

leatherman_dependency(util)
leatherman_dependency(nowide)
leatherman_dependency(locale)
leatherman_dependency(logging)
leatherman_dependency(file_util)
if (BUILDING_LEATHERMAN)
    leatherman_logging_namespace("leatherman.execution")
    leatherman_logging_line_numbers()
endif()

if(WIN32)
    leatherman_dependency(windows)
endif()

add_leatherman_headers(inc/leatherman)
if(WIN32)
    add_leatherman_library(src/execution.cc src/windows/execution.cc)
else()
    if("${CMAKE_SYSTEM_NAME}" MATCHES "SunOS")
        # LFS flags are needed to compile the posix/solaris/platform.cc such that it links correctly
        # against the libcontract library. They're not applied universally as they impact the ability
        # to use other OS functions. This usage is safe as long as global variables based on these flags
        # are avoided, according to http://docs.oracle.com/cd/E19455-01/806-0634/6j9vo5alu/index.html
        EXECUTE_PROCESS( COMMAND getconf LFS_CFLAGS OUTPUT_VARIABLE LFS_CFLAGS OUTPUT_STRIP_TRAILING_WHITESPACE )
        set(LEATHERMAN_CXX_FLAGS "${LEATHERMAN_CXX_FLAGS} ${LFS_CFLAGS}")
        add_leatherman_library(src/execution.cc src/posix/execution.cc src/posix/solaris/platform.cc)
    else()
        add_leatherman_library(src/execution.cc src/posix/execution.cc src/posix/generic/platform.cc)
    endif()
endif()

if(WIN32)
    set(PLATFORM_TESTS tests/windows/execution.cc)
else()
    set(PLATFORM_TESTS tests/posix/execution.cc)
    if("${CMAKE_SYSTEM_NAME}" MATCHES "SunOS")
        list(APPEND PLATFORM_TESTS tests/posix/solaris/execution.cc)
    endif()
endif()

add_leatherman_test(tests/log_capture.cc ${PLATFORM_TESTS})

if (BUILDING_LEATHERMAN)
    # Dumb implementation of cat.exe for testing stdin/stdout/stderr handling.
    include_directories(BEFORE ${LEATHERMAN_NOWIDE_INCLUDE})
    add_executable(lth_cat tests/lth_cat.cc)
    target_link_libraries(lth_cat ${LEATHERMAN_NOWIDE_LIBS})
    set_target_properties(lth_cat PROPERTIES COMPILE_FLAGS "${LEATHERMAN_CXX_FLAGS}")

    configure_file (
        "${CMAKE_CURRENT_LIST_DIR}/tests/fixtures.hpp.in"
        "${CMAKE_CURRENT_LIST_DIR}/tests/fixtures.hpp"
    )
endif()

=== file_util/CMakeLists.txt ===
find_package(Boost 1.54 REQUIRED COMPONENTS regex filesystem system)

add_leatherman_deps("${Boost_LIBRARIES}")
add_leatherman_includes("${Boost_INCLUDE_DIRS}")

leatherman_dependency(nowide)
leatherman_dependency(locale)
leatherman_dependency(logging)
leatherman_dependency(util)

if (BUILDING_LEATHERMAN)
    leatherman_logging_namespace("leatherman.file_util")
    leatherman_logging_line_numbers()
endif()

add_leatherman_library(src/directory.cc src/file.cc)
add_leatherman_headers(inc/leatherman)
add_leatherman_test(tests/file_utils_test.cc tests/directory_utils_test.cc tests/fixtures.cc)

=== locale/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,18 @@
 if (LEATHERMAN_USE_LOCALES)
     find_package(Boost 1.54 REQUIRED COMPONENTS locale system)
+    if (BOOST_STATIC AND LEATHERMAN_USE_ICU)
+        find_package(ICU COMPONENTS i18n uc)
+    endif()
 else()
     find_package(Boost 1.54 REQUIRED regex)
 endif()
 
 add_leatherman_includes(${Boost_INCLUDE_DIRS})
 add_leatherman_deps(${Boost_LIBRARIES})
+
+if (ICU_LIBRARIES)
+    add_leatherman_deps(${ICU_LIBRARIES})
+endif()
 
 if (LEATHERMAN_USE_LOCALES AND BOOST_STATIC AND APPLE)
     # Boost.Locale relies on libiconv; if not using shared boost libraries

=== tests/CMakeLists.txt ===
include_directories(BEFORE ${LEATHERMAN_CATCH_INCLUDE} ${LEATHERMAN_INCLUDE_DIRS})
add_executable(leatherman_test main.cc ${LEATHERMAN_TEST_SRCS})

if (LEATHERMAN_SHARED)
    # Include deps first, as they may be static. If they are, linking on Windows can
    # fail due to multiple definitions for the same symbol.
    set(LEATHERMAN_TEST_LIBS ${LEATHERMAN_DEPS} ${LEATHERMAN_LIBS})
else()
    set(LEATHERMAN_TEST_LIBS ${LEATHERMAN_LIBS} ${LEATHERMAN_DEPS})
endif()

if (LEATHERMAN_USE_CURL AND LEATHERMAN_INT_CURL_LIBS AND LEATHERMAN_TEST_CURL_LIB)
    list(REMOVE_ITEM LEATHERMAN_TEST_LIBS ${LEATHERMAN_INT_CURL_LIBS})
    list(APPEND LEATHERMAN_TEST_LIBS ${LEATHERMAN_TEST_CURL_LIB})
endif()

# We link libmock_curl instead of real libcurl in tests
target_link_libraries(leatherman_test ${LEATHERMAN_TEST_LIBS})

leatherman_logging_namespace("leatherman.test")
set_target_properties(leatherman_test PROPERTIES COMPILE_FLAGS "${LEATHERMAN_CXX_FLAGS}")
add_test(NAME "leatherman\\ tests" COMMAND leatherman_test)

=== debian/changelog ===
leatherman (1.4.2+dfsg-2build2) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 20:40:55 +0000

leatherman (1.4.2+dfsg-2build1) eoan; urgency=medium

  * No change rebuild against new boost regex icu encoded abi ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 08 May 2019 18:03:26 +0100

leatherman (1.4.2+dfsg-2) unstable; urgency=medium

  * Drop the libleatherman-data package; the translations shipped therein are
    actually test data
  * Fix option_set.count() "endless" loop (Closes: #905463)
  * Bump Standards-Version to 4.2.0; no changes needed

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Wed, 22 Aug 2018 16:09:39 +0300

leatherman (1.4.2+dfsg-1) unstable; urgency=medium

  [ Nicolas Dandrimont ]
  * Explicit build-dependency version constraints to ease backports
  * Force LC_CTYPE=C for tests as well

  [ Apollon Oikonomopoulos ]
  * B-D on ruby (Closes: #897553)
  * New upstream release
    + Bump SONAME to 1.4.2
  * Bump Standards-Version to 4.1.5; no changes needed
  * d/copyright: add Files-Excluded field
  * Disable -Werror (Closes: #897778)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Tue, 31 Jul 2018 15:06:39 +0800

=== debian/control ===
Source: leatherman
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Puppet Package Maintainers <pkg-puppet-devel@lists.alioth.debian.org>
Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 11~),
 libboost-dev,
 libboost-log-dev,
 libboost-locale-dev,
 libboost-thread-dev,
 libboost-date-time-dev,
 libboost-filesystem-dev,
 libboost-system-dev,
 libboost-chrono-dev,
 libboost-regex-dev,
 libcurl4-openssl-dev,
 libruby,
 ruby,
 rapidjson-dev,
 catch (>= 1.10~),
Standards-Version: 4.2.0
Section: libs
Homepage: https://github.com/puppetlabs/leatherman
Vcs-Git: https://salsa.debian.org/puppet-team/leatherman.git
Vcs-Browser: https://salsa.debian.org/puppet-team/leatherman

Package: libleatherman-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libleatherman1.4.2 (= ${binary:Version}),
 libboost-dev,
 libboost-log-dev,
 libboost-locale-dev,
 libboost-thread-dev,
 libboost-date-time-dev,
 libboost-filesystem-dev,
 libboost-system-dev,
 libboost-chrono-dev,
 libboost-regex-dev,
 libcurl4-openssl-dev,
 ${misc:Depends},
Description: collection of C++ and CMake utility libraries - development files
 Leatherman is a collection of C++ and CMake utility libraries, primarily used
 in the Puppet ecosystem.
 .
 This package contains the C++ headers and the CMake utility libraries.

Package: libleatherman1.4.2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: collection of C++ and CMake utility libraries - shared libraries
 Leatherman is a collection of C++ and CMake utility libraries, primarily used
 in the Puppet ecosystem.
 .
 This package contains the actual shared libraries.

=== debian/rules ===
--- 
+++ 
@@ -19,4 +19,4 @@
 	LC_ALL=C LC_CTYPE=C dh_auto_test
 
 override_dh_missing:
-	dh_missing --fail-missing
+	dh_missing --fail-missing -X.mo

## leatherman 1.12.1%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.2.2)
-project(leatherman VERSION 1.4.2)
+project(leatherman VERSION 1.12.1)
 
 if (WIN32)
     link_libraries("-Wl,--nxcompat -Wl,--dynamicbase")

## leatherman 1.12.1+dfsg

=== dynamic_library/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-find_package(Boost 1.54 REQUIRED COMPONENTS regex)
+find_package(Boost 1.54 REQUIRED COMPONENTS regex system)
 
 add_leatherman_deps("${Boost_LIBRARIES}")
 add_leatherman_includes("${Boost_INCLUDE_DIRS}")

=== execution/CMakeLists.txt ===
--- 
+++ 
@@ -63,3 +63,8 @@
         "${CMAKE_CURRENT_LIST_DIR}/tests/fixtures.hpp"
     )
 endif()
+
+check_library_exists(c closefrom /lib CLOSEFROM_IN_LIBC)
+if ("${CLOSEFROM_IN_LIBC}" STREQUAL "1")
+    add_definitions(-DHAS_CLOSEFROM)
+endif()

=== logging/CMakeLists.txt ===
find_package(Boost 1.54 REQUIRED COMPONENTS log log_setup thread date_time filesystem system chrono regex)
find_package(Threads)

add_leatherman_deps(${Boost_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
add_leatherman_includes("${Boost_INCLUDE_DIRS}")

leatherman_dependency(nowide)
leatherman_dependency(locale)

if (CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME MATCHES "SunOS")
    add_leatherman_deps(rt)
endif()

if (BUILDING_LEATHERMAN)
    leatherman_logging_namespace("leatherman.logging")
    leatherman_logging_line_numbers()
endif()

if(WIN32)
    set(PLATFORM_SRCS "src/windows/logging.cc")
    set(PLATFORM_TEST_SRCS "tests/windows/logging.cc")
else()
    set(PLATFORM_SRCS "src/posix/logging.cc")
    set(PLATFORM_TEST_SRCS "tests/posix/logging.cc")
endif()

if (LEATHERMAN_USE_LOCALES AND GETTEXT_ENABLED)
    list(APPEND PLATFORM_TEST_SRCS tests/logging_i18n.cc)
endif()

add_leatherman_library(src/logging.cc ${PLATFORM_SRCS})
add_leatherman_test(
    tests/logging.cc
    tests/logging_stream.cc
    tests/logging_stream_lines.cc
    tests/logging_on_message.cc
    ${PLATFORM_TEST_SRCS})
add_leatherman_headers(inc/leatherman)

if (LEATHERMAN_USE_LOCALES AND BUILDING_LEATHERMAN)
    project(leatherman_logging)
    add_subdirectory(locales)
endif()

=== rapidjson/CMakeLists.txt ===
add_leatherman_vendored("rapidjson-1.0.2.zip" "rapidjson" "include")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,9 @@
+set(BOOST_REQUIRED_COMPONENTS system date_time chrono log log_setup thread filesystem regex)
+if (LEATHERMAN_USE_LOCALES)
+    set(BOOST_REQUIRED_COMPONENTS ${BOOST_REQUIRED_COMPONENTS} locale)
+endif()
+find_package(Boost "1.54" REQUIRED COMPONENTS ${BOOST_REQUIRED_COMPONENTS})
+
 include_directories(BEFORE ${LEATHERMAN_CATCH_INCLUDE} ${LEATHERMAN_INCLUDE_DIRS})
 add_executable(leatherman_test main.cc ${LEATHERMAN_TEST_SRCS})

=== util/CMakeLists.txt ===
find_package(Boost 1.54 REQUIRED date_time chrono system)

add_leatherman_deps(${Boost_LIBRARIES})
add_leatherman_includes("${Boost_INCLUDE_DIRS}")

leatherman_dependency(nowide)

if(WIN32)
    set(PLATFORM_SRCS "src/windows/time.cc" "src/windows/environment.cc" "src/windows/scoped_handle.cc")
    set(PLATFORM_TESTS "tests/windows/environment.cc")
else()
    set(PLATFORM_SRCS "src/posix/time.cc" "src/posix/environment.cc" "src/posix/scoped_descriptor.cc")
    set(PLATFORM_TESTS "tests/posix/environment.cc")
endif()

add_leatherman_headers(inc/leatherman)

add_leatherman_library(
    src/strings.cc
    src/time.cc
    src/environment.cc
    src/scope_exit.cc
    src/scoped_env.cc
    src/uri.cc
    ${PLATFORM_SRCS}
    )

add_leatherman_test(
    tests/scoped_env.cc
    tests/strings_test.cc
    tests/option_set.cc
    tests/environment.cc
    tests/timer.cc
    tests/uri.cc
    ${PLATFORM_TESTS}
    )

=== windows/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-find_package(Boost 1.54 REQUIRED COMPONENTS filesystem)
+find_package(Boost 1.54 REQUIRED COMPONENTS filesystem regex system)
 
 add_leatherman_deps(Wbemuuid.lib userenv.lib "${Boost_LIBRARIES}")
 add_leatherman_includes("${Boost_INCLUDE_DIRS}")

=== curl/tests/CMakeLists.txt ===
find_package(CURL REQUIRED)

include_directories(BEFORE ${CURL_INCLUDE_DIRS})

if (CURL_STATIC)
    set(CURL_LINK STATIC)
else()
    set(CURL_LINK SHARED)
endif()
add_library(mock_curl ${CURL_LINK} mock_curl.cc)
set_target_properties(mock_curl PROPERTIES COMPILE_FLAGS "${LEATHERMAN_CXX_FLAGS}")
if (WIN32)
    symbol_exports(mock_curl "${CMAKE_CURRENT_LIST_DIR}/export.h")
endif()

# Namespacing curl libs so we don't pollute the global namespace
# Needed to properly link libmock_curl in tests
set(LEATHERMAN_INT_CURL_LIBS ${CURL_LIBRARIES})
export_var(LEATHERMAN_INT_CURL_LIBS)

set(LEATHERMAN_TEST_CURL_LIB mock_curl)
export_var(LEATHERMAN_TEST_CURL_LIB)

=== locale/locales/CMakeLists.txt ===
if (LEATHERMAN_TOPLEVEL)
    gettext_templates(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../tests/locale.cc)
endif()
gettext_compile(${CMAKE_CURRENT_SOURCE_DIR} share/locale)
SET_DIRECTORY_PROPERTIES(PROPERTIES CLEAN_NO_CUSTOM TRUE)

=== debian/changelog ===
leatherman (1.12.1+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * [517b59d] Add .gitlab-ci.yml
  * [37dd667] Use packaged libboost-nowide. (Closes: #975863)

 -- Anton Gladky <gladk@debian.org>  Sun, 13 Dec 2020 23:11:38 +0100

leatherman (1.12.1+dfsg-1) unstable; urgency=medium

  * New upstream release
    + Bump SONAME to 1.12.1
    + Drop cmake-ftbfs.patch; fixed upstream
  * Acknowledge 1.4.2+dfsg-2.1 NMU; thanks to Dimitri John Ledkov and Adrian
    Bunk!
  * Bump Standards-Version to 4.5.0; no changes needed
  * Bump dh compat to 13; no changes needed
  * Use upstream build flag to disable -Werror
  * d/copyright: bump debian/* years

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Tue, 25 Aug 2020 11:53:57 +0300

leatherman (1.4.2+dfsg-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * Add patch to fix ftbfs with Boost 1.71. (Closes: #960416)

 -- Adrian Bunk <bunk@debian.org>  Mon, 15 Jun 2020 18:36:13 +0300

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: leatherman
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Puppet Package Maintainers <pkg-puppet-devel@lists.alioth.debian.org>
+Maintainer: Puppet Package Maintainers <pkg-puppet-devel@lists.alioth.debian.org>
 Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 11~),
- libboost-dev,
+ debhelper-compat (= 13),
+ libboost-dev (>=1.73.0),
  libboost-log-dev,
+ libboost-nowide-dev,
  libboost-locale-dev,
  libboost-thread-dev,
  libboost-date-time-dev,
@@ -20,7 +20,7 @@
  ruby,
  rapidjson-dev,
  catch (>= 1.10~),
-Standards-Version: 4.2.0
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/puppetlabs/leatherman
 Vcs-Git: https://salsa.debian.org/puppet-team/leatherman.git
@@ -31,10 +31,11 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libleatherman1.4.2 (= ${binary:Version}),
+ libleatherman1.12.1 (= ${binary:Version}),
  libboost-dev,
  libboost-log-dev,
  libboost-locale-dev,
+ libboost-nowide-dev,
  libboost-thread-dev,
  libboost-date-time-dev,
  libboost-filesystem-dev,
@@ -49,7 +50,7 @@
  .
  This package contains the C++ headers and the CMake utility libraries.
 
-Package: libleatherman1.4.2
+Package: libleatherman1.12.1
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg\d*$//" \
  https://github.com/puppetlabs/leatherman/releases  .*/([\d.]+)/leatherman.tar.gz
